package cn.ibizlab.core.sample.mapper;

import java.util.List;
import org.apache.ibatis.annotations.*;
import java.util.Map;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.core.conditions.Wrapper;
import java.util.HashMap;
import org.apache.ibatis.annotations.Select;
import cn.ibizlab.core.sample.domain.IBIZOrder;
import cn.ibizlab.core.sample.filter.IBIZOrderSearchContext;
import org.springframework.cache.annotation.CacheEvict;
import org.springframework.cache.annotation.Cacheable;
import java.io.Serializable;
import com.baomidou.mybatisplus.core.toolkit.Constants;
import com.alibaba.fastjson.JSONObject;

public interface IBIZOrderMapper extends BaseMapper<IBIZOrder> {

    Page<IBIZOrder> searchCSDY(IPage page, @Param("srf") IBIZOrderSearchContext context, @Param("ew") Wrapper<IBIZOrder> wrapper);
    Page<IBIZOrder> searchCurState30(IPage page, @Param("srf") IBIZOrderSearchContext context, @Param("ew") Wrapper<IBIZOrder> wrapper);
    Page<IBIZOrder> searchDDJETJBB(IPage page, @Param("srf") IBIZOrderSearchContext context, @Param("ew") Wrapper<IBIZOrder> wrapper);
    Page<IBIZOrder> searchDDReport(IPage page, @Param("srf") IBIZOrderSearchContext context, @Param("ew") Wrapper<IBIZOrder> wrapper);
    Page<IBIZOrder> searchDYDDMXSJY(IPage page, @Param("srf") IBIZOrderSearchContext context, @Param("ew") Wrapper<IBIZOrder> wrapper);
    Page<IBIZOrder> searchDefault(IPage page, @Param("srf") IBIZOrderSearchContext context, @Param("ew") Wrapper<IBIZOrder> wrapper);
    Page<IBIZOrder> searchEchartsDefaultDataSource(IPage page, @Param("srf") IBIZOrderSearchContext context, @Param("ew") Wrapper<IBIZOrder> wrapper);
    Page<IBIZOrder> searchGaugeDataSource(IPage page, @Param("srf") IBIZOrderSearchContext context, @Param("ew") Wrapper<IBIZOrder> wrapper);
    Page<IBIZOrder> searchGaugeDataSourceByTime(IPage page, @Param("srf") IBIZOrderSearchContext context, @Param("ew") Wrapper<IBIZOrder> wrapper);
    Page<IBIZOrder> searchLOGIC_22(IPage page, @Param("srf") IBIZOrderSearchContext context, @Param("ew") Wrapper<IBIZOrder> wrapper);
    Page<IBIZOrder> searchRadarDataSource(IPage page, @Param("srf") IBIZOrderSearchContext context, @Param("ew") Wrapper<IBIZOrder> wrapper);
    Page<IBIZOrder> searchSHZOrder(IPage page, @Param("srf") IBIZOrderSearchContext context, @Param("ew") Wrapper<IBIZOrder> wrapper);
    Page<IBIZOrder> searchState10(IPage page, @Param("srf") IBIZOrderSearchContext context, @Param("ew") Wrapper<IBIZOrder> wrapper);
    Page<IBIZOrder> searchState30(IPage page, @Param("srf") IBIZOrderSearchContext context, @Param("ew") Wrapper<IBIZOrder> wrapper);
    Page<IBIZOrder> searchState40(IPage page, @Param("srf") IBIZOrderSearchContext context, @Param("ew") Wrapper<IBIZOrder> wrapper);
    Page<IBIZOrder> searchXECX(IPage page, @Param("srf") IBIZOrderSearchContext context, @Param("ew") Wrapper<IBIZOrder> wrapper);
    @Override
    IBIZOrder selectById(Serializable id);
    @Override
    int insert(IBIZOrder entity);
    @Override
    int updateById(@Param(Constants.ENTITY) IBIZOrder entity);
    @Override
    int update(@Param(Constants.ENTITY) IBIZOrder entity, @Param("ew") Wrapper<IBIZOrder> updateWrapper);
    @Override
    int deleteById(Serializable id);
    /**
    * 自定义查询SQL
    * @param sql
    * @return
    */
    @Select("${sql}")
    List<JSONObject> selectBySQL(@Param("sql") String sql, @Param("et")Map param);

    /**
    * 自定义更新SQL
    * @param sql
    * @return
    */
    @Update("${sql}")
    boolean updateBySQL(@Param("sql") String sql, @Param("et")Map param);

    /**
    * 自定义插入SQL
    * @param sql
    * @return
    */
    @Insert("${sql}")
    boolean insertBySQL(@Param("sql") String sql, @Param("et")Map param);

    /**
    * 自定义删除SQL
    * @param sql
    * @return
    */
    @Delete("${sql}")
    boolean deleteBySQL(@Param("sql") String sql, @Param("et")Map param);

    List<IBIZOrder> selectByIbizcustomerid(@Param("ibizcustomerid") Serializable ibizcustomerid);

}
